clear all;
close all;
clc

data_dir = [pwd filesep 'validation' filesep];

%% Add this directory to the MATLAB path.
addpath(pwd)


%% Check for previous files before starting validation procedure
% answers = dir(['answers.txt']);
% if(~isempty(answers))
%     while(1)
%         display(['Found previous answer sheet file in: ' pwd])
%         cont = upper(input('Delete it (Y/N/Q)?','s'));
%         if(strcmp(cont,'Y') || strcmp(cont,'N') || strcmp(cont,'Q'))
%             if(~strcmp(cont,'Y'))
%                 display('Exiting script!!')
%                 return;
%             end
%             break;
%         end
%     end
%     display('Removing previous answer sheet.')
%     delete(answers.name);
% end

%% Load the list of records in the validation set.
fid = fopen([data_dir 'records_af'],'r');
if(fid ~= -1)
    RECLIST = textscan(fid,'%s');
else
    error(['Could not open ' data_dir 'RECORDS for scoring. Exiting...'])
end
fclose(fid);
records_af = RECLIST{1};

%% Running on the validation set and obtain the score results



for i=30 %:length(records_normal)
  
    fname = records_af{i};
    [tm,noisyECG,SamplingFreq,siginfo]=rdmat(fname);
    ecg_baseline=BaselineWanderRemovalMedian( noisyECG, SamplingFreq);
    [ecg_baseline_normalise] = normalise_signal(ecg_baseline);
    [QRS,sign,en_thres] = qrs_detect2( ecg_baseline_normalise',0.25,0.6,SamplingFreq); 
%   ecgc=omit_beats(ecg,QRS);
%   [QRS,sign,en_thres] = qrs_detect2( ecg_baseline_normalise',0.25,0.6,SamplingFreq);
    if sign < 0
     ecg_baseline_normalise= (ecg_baseline_normalise*-1);
   end
   
   ss_tot=0;
   ss1=0;
   ss2=0;
   ss3=0;
   ss4=0;
   ss5=0;
for j=1:(size(QRS,2)-1)

ss1=ecg_baseline_normalise(QRS(j):QRS(j+1));
ss2=find(ss1<=0);
if ss2==0
    
  ss_tot(j,1)=0;
  ss_tot(j,2)=0;
end 

if ss2~=0
    
ss3=sort(ss2);
ss4=min(ss3)+QRS(j)+0.4*(max(ss3)-min(ss3));
ss5=max(ss3)+QRS(j);
ss_tot(j,1)=fix(ss4);
ss_tot(j,2)=ss5;
end
end

index=find(ss_tot(:,1)==0);

ss_tot(index,:)=[];

ss_bandpower=0;

 ss=0;

ecg_baseline_normalise2=zeros(length(ecg_baseline_normalise),1);
for k=1:size(ss_tot,1)
ecg_baseline_normalise2(ss_tot(k,1):ss_tot(k,2))=ecg_baseline_normalise(ss_tot(k,1):ss_tot(k,2));

end
plot(ecg_baseline_normalise) 
hold on 
plot(ecg_baseline_normalise2,'r')

end
