function coordmat = sierpinski(height)

% SIERPINSKI(HEIGHT) Draw the Sierpinski gasket of height
% HEIGHT. Uses the Pascal triangle analogy to assemble the
% structure. 
%    Example:
%       sierpinski(64);  
% returns the coordinates of the sierpinski set in coordmat

% This file was generated by students as a partial fulfillment 
% for the requirements of the course "Classical Mathematical
% Theorems and their Visualisation on the Computer", Winter term
% 2002/2003, Stuttgart University.	
	
% Author : Dagmar Scherzinger, Carsten Reisser
% Date   : Dec 2002
% Version: 1.0
	
if nargin ~= 1
	error(['One input argument is required. Please type ' ... 
				 '''help sierpinski'' for usage information.']);
end

hold on;
coordvec = [];
for y=0:height-1
    for x=0:y
        if bitand(x,(y-x)) == 0
	   coordvec(end+1) = x+height-.5*y;
	   coordvec(end+1) = height/2-(y);
       end
    end
end
coordmat = zeros(length(coordvec)/2,2);
coordmat(:,1) = coordvec(1:2:end);
coordmat(:,2) = coordvec(2:2:end);

plot(coordmat(:,1), coordmat(:,2),'r.');
axis equal; axis off;
set(gca,'FontSize',14);
set(gcf,'Color',[1,1,1]);
title('The Sierpinski Gasket');
hold off;