clear all;
close all;
clc

data_dir = [pwd filesep 'validation' filesep];

%% Add this directory to the MATLAB path.
addpath(pwd)

%% Check for previous files before starting validation procedure
% answers = dir(['answers.txt']);
% if(~isempty(answers))
%     while(1)
%         display(['Found previous answer sheet file in: ' pwd])
%         cont = upper(input('Delete it (Y/N/Q)?','s'));
%         if(strcmp(cont,'Y') || strcmp(cont,'N') || strcmp(cont,'Q'))
%             if(~strcmp(cont,'Y'))
%                 display('Exiting script!!')
%                 return;
%             end
%             break;
%         end
%     end
%     display('Removing previous answer sheet.')
%     delete(answers.name);
% end

%% Load the list of records in the validation set.
fid = fopen([data_dir 'RECORDS_other'],'r');
if(fid ~= -1)
    RECLIST = textscan(fid,'%s');
else
    error(['Could not open ' data_dir 'RECORDS for scoring. Exiting...'])
end
fclose(fid);
RECORDS = RECLIST{1};

%% Running on the validation set and obtain the score results
classifyResult = zeros(length(RECORDS),1);
total_time     = 0;

fid=fopen('answers.txt','wt');

  for i=1:1500 %:length(RECORDS)
 
 
R2=0;
R4=0;
  
  
    fname = RECORDS{i};
        [tm,noisyECG,SamplingFreq,siginfo]=rdmat(fname);
    ecg_baseline=BaselineWanderRemovalMedian( noisyECG, SamplingFreq);
    [ecg_baseline_normalise] = normalise_signal(ecg_baseline);
    [QRS,sign,en_thres] = qrs_detect2( ecg_baseline_normalise',0.25,0.6,SamplingFreq); 
    if length(QRS)>1
        
%   ecgc=omit_beats(ecg,QRS);
%   [QRS,sign,en_thres] = qrs_detect2( ecg_baseline_normalise',0.25,0.6,SamplingFreq);
    if sign < 0
     ecg_baseline_normalise= (ecg_baseline_normalise*-1);
    end
    ecgc=omit_beats(ecg_baseline_normalise,QRS);
   if length (ecgc)>300
    [QRS2,sign,en_thres] = qrs_detect2(ecgc',0.25,0.6,300);
 if ~isempty(QRS2)   
    R=cell(1,(length(QRS2)-2));
   
    for j=1:length(QRS2)-2
    r=xcorr(ecgc(QRS2(1,j):QRS2(1,j+1)),ecgc(QRS2(1,j+1):QRS2(1,j+2)));
    R{j}=r;
    end
    R2=cell2mat(R');
%     figure
%     plot(R2,'m')

     R3=cell(1,(length(R)-1));
  
    for k=1:length(R)-1
        r2=xcorr(cell2mat(R(1,k)),cell2mat(R(1,k+1)));
        R3{k}=r2;
    end
    R4=cell2mat(R3');
    
    if ~isempty(R4)
%     figure
%     plot(R4)
  
%     R5=cell(1,(length(R3)-1));
%     
%     for l=1:length(R3)-1
%         r3=xcorr(cell2mat(R3(1,l)),cell2mat(R3(1,l+1)));
%         R5{k}=r3;
%     end
%     R6=cell2mat(R5');
    
%      if ~isempty(R6)
%     figure
%     plot(R6,'r')
%    
%% fractal coo1
e1=0;
for w=1:length(R2);
    e1(w)=w;
end
e1=e1';

Rx=[R2,e1];

frac_dim_corr1 = boxcount(Rx,5,0);

corr1_frac_dim_corr1_tot_other(i)=frac_dim_corr1;
%% fractal corr2
e2=0;
for w=1:length(R4);
    e2(w)=w;
end
e2=e2';

Rx=[R4,e2];

frac_dim_corr2 = boxcount(Rx,5,0);

corr2_frac_dim_tot_other(i)=frac_dim_corr2;



end 
end


%%   feature extraction

%%first mean amplitute in each corr
% amplitute=0;
%  for m=1:length(R)    
%  amplitute(m)=mean(abs((cell2mat(R(1,m)))));
%  end
%  amplitute_normal{i}=amplitute;
% xx=abs(R2);
% amplitute_normal_kolecorr(i)=mean(xx);

  end
  end
  end
